#include "config.h"
#include "ImgLoader.h"
#include "ImgSaver.h"
#include <locale.h>
int wmain(int argc, wchar_t** argv)
{
	setlocale(LC_ALL, "chs");
	CImageFactory imgFactory;

	//GdiplusϵͼƬ
	imgFactory.RegisterLoader(TplClassOfLoader<CImgLoaderByGdiplus>());
	imgFactory.RegisterSaver(TplClassOfSaver<CImgSaverByGdiplus>());

#ifdef SUPPORT_FREEIMAGE
	//FreeImageͼƬ
	imgFactory.RegisterLoader(TplClassOfLoader<CImgLoaderByFreeImage>());
#endif

#ifdef SUPPORT_SVG_TYPE
	imgFactory.RegisterLoader(TplClassOfLoader<CImgLoaderByNanoSvg>());
#endif

	//ⲿ
	if (argc < 3)
	{
		std::wstring szImgList;
		imgFactory.GetImgListForSaver(szImgList);
		std::wstring szTemp(L"ָѡ");
		szTemp += szImgList;
		wprintf(L"imageConverter.exe srcPath destPath [imgType]\n"
			L"%-15s%s\n"
			L"%-15s%s\n"
			L"%-15s%s\n",
			L"srcPath", L"ͼƬ·input.png",
			L"destPath", L"ͼƬ·output.jpg",
			L"[imgType]", szTemp.c_str()
		);
		wprintf(L"˳...");
		getchar();
		return 0;
	}

	//ͼƬʽת
	Gdiplus::Image *pImg = imgFactory.InvokeLoader(argv[1]);
	imgFactory.InvokeSaver(argv[2], pImg, argv[3]);
	delete pImg;
	pImg = NULL;
    return 0;
}
