/*****************************************************************************
*  @file     CAutoRegisterFactory.h
*  @brief    עĹģ
*  @note
*  󱻹ŵָΪӶôһģ
*****************************************************************************/
#ifndef __CAUTOREGISTERFACTORY_H
#define __CAUTOREGISTERFACTORY_H

#include <map>
#include <list>
#include <windows.h>

/**
* @class IForwarder
* @brief ת
* @note
* ѹģʽµֳõĵ÷ʽг󣬽
* ɸ[CloneClass()]/ֱӵ[InvokeClass()]
*/
template<typename TBase>
class IForwarder
{
public:
	virtual ~IForwarder() {}

public:
	/**
	* @brief: ͨ˽ӿһָġס
	* @return TBase* ػָĸ
	* @note
	*
	*/
	virtual TBase *CloneClass() = 0;

	/**
	* @brief: ͨ˽ӿֱӵָ
	* @return TBase* ػָ
	* @note
	*
	*/
	virtual TBase* InvokeClass() = 0;

	/**
	* @brief: ͨ˽ӿһתָ
	* @return TBase* תָ
	* @note
	* ע⣬˴˺ôҪֶ
	* ͷһڴŶ
	*/
	virtual IForwarder<TBase>* Clone() = 0;
};

/**
* @class CSigleRegisterFactory
* @brief һ֧ԶעĹģ
* @note
* ע⣬TKeyԶͣôϵŶ
* 忴std::mapͨҪ<뿴
* https://msdn.microsoft.com/ZH-CN/library/s44w4h2s(v=VS.100,d=hv.2).aspx
* gcc±⣺http://blog.csdn.net/pb1995/article/details/49532285
* ֧һһģʽ
*/
template<typename TKey, typename TBase>
class CSingleRegisteredFactory
{
	typedef IForwarder<TBase> ImpForwarder;
public:
	CSingleRegisteredFactory() {}
	virtual ~CSingleRegisteredFactory()
	{
		typename std::map<TKey, ImpForwarder*>::iterator it = m_mapClasses.begin();
		for (; it != m_mapClasses.end(); it++)
		{
			ImpForwarder* pTemp = it->second;
			if (NULL != pTemp)
			{
				delete pTemp;
				pTemp = NULL;
			}
		}
	}

	/**
	* @brief: עĻָĸ
	* @param[in] TKey  Key  ָ
	* @return TBase* ػָ룬ҲôֱӷNULL
	* @note
	* ע⣬ô˺֮󣬻Ҫ֤һָǷЧ
	*/
	TBase* CloneClass(TKey Key)
	{
		if (IsAddedInFactory(Key))
		{
			return m_mapClasses[Key]->CloneClass();
		}
		OutputDebugStringA("ؿָ룬ಢûбעᣡ\n");
		return NULL;
	}

	/**
	* @brief: עĻָ
	* @param[in] TKey  Key  ָ
	* @return TBase* ػָ룬ҲôֱӷNULL
	* @note
	* ע⣬ô˺֮󣬻Ҫ֤һָǷЧ
	*/
	TBase* InvokeClass(TKey Key)
	{
		if (IsAddedInFactory(Key))
		{
			return m_mapClasses[Key]->InvokeClass();
		}
		OutputDebugStringA("ؿָ룬ಢûбעᣡ\n");
		return NULL;
	}

	/**
	* @brief: ѹʵ֮еĳзע
	* @param[in] TKey  Key  ָ
	* @return 
	* @note
	*
	*/
	void UnregisterFactory(TKey Key)
	{
		if (!IsAddedInFactory(Key))
			return;
		ImpForwarder *pTemp = m_mapClasses[Key];
		if (NULL != pTemp)
		{
			delete pTemp;
			pTemp = NULL;
			m_mapClasses.erase(m_mapClasses.find(Key));
		}
	}

	/**
	* @brief: ĳעᵽʵ֮
	* @param[in] TKey  Key  ĳⲿʱõַͨöٵ
	* @param[in|out] IForwarder<TBase>*  pObj  עᵽʵĻָ룬Զָ
	* @param[in] bool  bIsOverWrite  Ϊtrueעֱ࣬ͷŴעĻָ
	* @return 
	* @note
	* ԶҪעᵽ๤Ļָ룬ҪظעָԶͷ
	*/
	void RegisterFactory(TKey Key, ImpForwarder *pObj, bool bIsOverWrite = false)
	{
		if (NULL == pObj)
		{
			OutputDebugStringA("ǲˮ㣬עĻָ뾹ȻΪգ\n");
			return;
		}

		if (IsAddedInFactory(Key))
		{
			if (!bIsOverWrite)
			{
				OutputDebugStringA("ѾͷظעָˣҪظͷŶ\n");
				delete pObj;
				pObj = NULL;
				return;
			}
			UnregisterFactory(Key);
		}
		m_mapClasses[Key] = pObj;
	}

	bool IsAddedInFactory(TKey Key) { return m_mapClasses.find(Key) != m_mapClasses.end() ? true : false; }

	std::list<TKey> GetKeys()
	{
		std::list<TKey> vcKeys;
		typename std::map<TKey, ImpForwarder*>::iterator it = m_mapClasses.begin();
		for (; it != m_mapClasses.end(); it++)
			vcKeys.push_back(it->first);
		return vcKeys;
	}

private:
	std::map<TKey, ImpForwarder*> m_mapClasses;

};


/**
* @class CMutipleRegisterFactory
* @brief һ֧ԶעĹģ
* @note
* ע⣬TKeyԶͣôϵŶ
* 忴std::mapͨҪ<뿴
* https://msdn.microsoft.com/ZH-CN/library/s44w4h2s(v=VS.100,d=hv.2).aspx
* gcc±⣺http://blog.csdn.net/pb1995/article/details/49532285
* ֧һԶķʽͨźŲ
* ע⣬ҪΪĻඨһ麯virtual bool Equal(const TBase & sour)const = 0;
* ȻأȽظע¼ģԭ˹ǲ==ʵֵ
* ǵʱԴɶԲã˸ı
*/
template<typename TKey, typename TBase>
class CMutipleRegisteredFactory
{
	typedef IForwarder<TBase> ImpForwarder;
	typedef std::list<ImpForwarder*> ForwardContainter;
public:
	CMutipleRegisteredFactory() {}
	virtual ~CMutipleRegisteredFactory()
	{
		typename std::map<TKey, ForwardContainter>::iterator it = m_mapContainer.begin();
		for (; it != m_mapContainer.end(); it++)
		{
			UnregisterContainter(it->first);
		}
	}

	/**
	* @brief: ѹʵ֮еĳзע
	* @param[in] TKey  Key  ָ
	* @return 
	* @note
	* ǰID¼ȫȫ¼
	* ע⣬bIsAllΪtrueʱͷбע¼ָ룬
	* Ϊfalseͷָ¼Ӧָ
	*/
	void UnregisterContainter(TKey Key,bool bIsAll = true, ImpForwarder *pObj = NULL)
	{
		if(IsAddedInFactory(Key))
		{
			ForwardContainter &temp = m_mapContainer[Key];
			typename ForwardContainter::iterator it = temp.begin();
			for(;it!=temp.end();it++)
			{
				ImpForwarder *pTemp2 = *it;
				if(bIsAll)
				{
					delete pTemp2;
					pTemp2 = NULL;
				}else{
					if(NULL != pObj)
					{
						//жߵָӦʵϢǷͬ
						if( pTemp2->InvokeClass()->Equal(*pObj->InvokeClass()))
						{
							delete pTemp2;
							pTemp2 = NULL;
							//ɾstd::list()Ԫ
							it = temp.erase(it);
							break;
						}
					}else
						break;
				}
			}
		}
		if(NULL != pObj)
		{
			delete pObj;
			pObj = NULL;
		}
	}

	/**
	* @brief: ĳעᵽʵ֮
	* @param[in] TKey  Key  ĳⲿʱõַͨöٵ
	* @param[in|out] IForwarder<TBase>*  pObj  עᵽʵĻָ룬Զָ
	* @param[in] bool  bIsOverWrite  Ϊtrueעֱ࣬ͷŴעĻָ
	* @return 
	* @note
	* ԶҪעᵽ๤Ļָ룬ҪظעָԶͷ
	*/
	void RegisterFactory(TKey Key, ImpForwarder *pObj)
	{
		if (NULL == pObj)
		{
			OutputDebugStringA("ǲˮ㣬עĻָ뾹ȻΪգ\n");
			return;
		}

		if(!IsAddedInFactory(Key))
		{
			ForwardContainter obj;
			m_mapContainer[Key]= obj;
		}

		ForwardContainter &temmp = m_mapContainer[Key];
		typename ForwardContainter::iterator it = temmp.begin();
		for(;it!=temmp.end();it++)
		{
			ImpForwarder *pTemp2 = *it;
			//жߵָӦʵϢǷͬ
			if(pTemp2->InvokeClass()->Equal(*pObj->InvokeClass()))
			{
				delete pObj;
				pObj = NULL;
				return;
			}
		}
		m_mapContainer[Key].push_back(pObj);
	}

	bool IsAddedInFactory(TKey Key) 
	{ 
		return m_mapContainer.find(Key) != m_mapContainer.end() ? true : false; 
	}

	ForwardContainter* InvokeContanter(TKey Key)
	{
		if (IsAddedInFactory(Key))
		{
			return &m_mapContainer[Key];
		}
		return NULL;
	}

	std::list<TKey> GetKeys()
	{
		std::list<TKey> vcKeys;
		typename std::map<TKey, ImpForwarder*>::iterator it = m_mapClasses.begin();
		for (; it != m_mapClasses.end(); it++)
			vcKeys.push_back(it->first);
		return vcKeys;
	}

private:
	std::map<TKey, ForwardContainter> m_mapContainer;
};

#endif
